"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.filterOncePerParams = filterOncePerParams;
exports.callOncePerParam = callOncePerParam;
exports.clearRunning = exports.getRunning = void 0;

var _effects = require("redux-saga/effects");

function _toArray(arr) { return _arrayWithHoles(arr) || _iterableToArray(arr) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

const runningCalls = new Set();

function* filterOncePerParams(id, _ref) {
  let _ref2 = _toArray(_ref),
      callFn = _ref2[0],
      callParams = _ref2.slice(1);

  const identityParam = Array.isArray(id) ? id.join('-') : id;

  if (runningCalls.has(identityParam)) {
    return;
  }

  runningCalls.add(identityParam);

  try {
    yield (0, _effects.call)(callFn, ...callParams);
  } catch (error) {
    console.warn(error);
  }

  runningCalls.delete(identityParam);
}

function* callOncePerParam(id, callFnWithParams) {
  yield (0, _effects.call)(filterOncePerParams, id, callFnWithParams);
}

const getRunning = () => runningCalls.entries;

exports.getRunning = getRunning;

const clearRunning = () => runningCalls.clear();

exports.clearRunning = clearRunning;
